---
title: asm.js
slug: Games/Tools/asm.js
tags:
  - Deprecated
  - JavaScript
  - asm.js
---
<div>{{Deprecated_header}}</div>

<div>{{GamesSidebar}}</div>

<div class="summary">
<p><span class="seoSummary"><a href="http://asmjs.org/">Asm.js</a> is a specification defining a subset of JavaScript that is highly optimizable. This article looks at exactly what is permitted in the asm.js subset, what improvements it confers, where and how you can make use of it, and further resources and examples.</span></p>
</div>

<h2 id="What_is_asm.js_exactly">What is asm.js, exactly?</h2>

<p>It is a very small, strict subset of JavaScript that only allows things like `while`, `if`, numbers, top-level named functions, and other simple constructs. It does not allow objects, strings, closures, and basically anything that requires heap allocation. Asm.js code resembles C in many ways, but it's still completely valid JavaScript that will run in all current engines. It pushes JS engines to optimize this kind of code, and gives compilers like <a href="https://github.com/kripken/emscripten">Emscripten</a> a clear definition of what kind of code to generate. We will show what asm.js code looks like and explain how it helps and how you can use it.</p>

<p>This subset of JavaScript is already highly optimized in many JavaScript engines using fancy Just-In-Time (JIT) compiling techniques. However, by defining an explicit standard we can work on optimizing this kind of code even more and getting as much performance as we can out of it. It makes it easier to collaborate across multiple JS engines because it's easy to talk about and benchmark. The idea is that this kind of code <strong>should</strong> run very fast in each engine, and if it doesn't, it's a bug and there's a clear spec that engines should optimize for.</p>

<p>It also makes it easy for people writing compilers that want to generate high-performant code on the web. They can consult the asm.js spec and know that it will run fast if they adhere to asm.js patterns. <a href="https://github.com/kripken/emscripten">Emscripten</a>, a C/C++ to JavaScript compiler, emits asm.js code to make it run with near native performance on several browsers.</p>

<p>Additionally, if an engine chooses to specially recognize asm.js code, there even more optimizations that can be made. Firefox is the only browser to do this right now.</p>

<h2 id="asm.js_language_summary">asm.js language summary</h2>

<p>asm.js is an intermediate programming language.  asm.js has a very predictable perfomance rate because it is limited to an extremely restricted subset of JavaScript that provides only strictly-typed integers, floats, arithmetic, function calls, and heap accesses.  The performance characteristics are closer to native code than that of standard JavaScript.  Using a subset of JavaScript asm.js is already supported by major web browsers.   Since asm.js runs in a browser it depends heavily on the browser and the hardware.</p>
